/*
*ejemplo6_31
*ejemplo6_31.c
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "agenda.h"
/*DECLARACIONES DE CONSTANTES*/
#define PANTALLA 5 /*numero de Contactos que se pueden visualizar en pantalla*/
#define OPCIONES_MENU 7 /*numero de opciones del men*/

/*NOMBRE DEL ARCHIVO SOBRE EL QUE SE TRABAJA*/
char nombreArchivo[100]="listin.dat";
/*DECLARACIONES DE FUNCIONES*/
int imprimeMenu(const char *fichero);
void leerContacto() ;
void pideNombreYMuestraContacto();
void mostrarContacto (Contacto contacto);
int buscarContacto();
void borrarContacto();
void guardarArchivo();
void modificarContacto();
void imprimirAgenda ();
void esperarPorTecla();

int main() {
    int opcionMenu=0;
    if(inicializarAgenda(nombreArchivo) == ERROR) {
        printf( "Agenda vacia; comience a introducir datos\n\n");
    }
    while (1) {
        switch (opcionMenu=imprimeMenu(nombreArchivo)) {
        case 1:
            leerContacto();
            break;
        case 2:
            borrarContacto();
            break;
        case 3:
            pideNombreYMuestraContacto();
            break;
        case 4:
            imprimirAgenda();
            break;
        case 5:
            modificarContacto();
            break;
        case 6:
            guardarArchivo();
            break;
        case 7:
            exit(0);
        }
        esperarPorTecla();
    }
    return 0;
}

int imprimeMenu(const char *fichero) {
    int opcion=0;
    printf("------------------------ NOMBRE DEL LISTIN: %s ---------------------\n", fichero);
    printf("\n\t\t\t\n");
    printf("\t\t\t1.Introducir contacto  \n");
    printf("\t\t\t2.Borrar contacto      \n");
    printf("\t\t\t3.Buscar contacto      \n");
    printf("\t\t\t4.Listar agenda        \n");
    printf("\t\t\t5.Modificar contacto   \n");
    printf("\t\t\t6.Guardar              \n");
    printf("\t\t\t7.Salir                \n");
    printf("\t\t\tͼ\n");
    do {
        printf("-------Introducir opcion [1-%d]: ",OPCIONES_MENU);
        scanf("%d",&opcion);
    } while (opcion<0 || opcion > OPCIONES_MENU);
    fflush(stdin);
    system("cls");
    return opcion;
}

void leerContacto() {
    Contacto contacto;
    printf("\n\n\n\n");
    printf("Introduce el nombre: ");
    gets(contacto.nombre);
    printf("Introduce la direccin: ");
    gets(contacto.direccion);
    printf("Introduce el telefono: ");
    gets(contacto.telefono);
    int error = introducirContactoEnAgenda(contacto);
    if (error == ERROR) {
        printf("El listin telefonico esta lleno, no se puede introducir\n");
    } else {
        printf ("El contacto ha sido introducido conxito\n");
    }
}

void pideNombreYMuestraContacto() {
    int posicion;
    printf("\n\n\n\t Buscando un contacto");
    posicion = buscarContacto();
    if (posicion==ERROR) {
        printf ("El contacto no se encuentra\n");
    } else {
        mostrarContacto(recuperarContactoDeAgenda(posicion));
    }
}

int buscarContacto() {
    char nombre[LNOMBRE];
    printf("\n\n\n\t Introduce el nombre:");
    gets(nombre);
    printf("\n");
    return buscarContactoEnAgenda(nombre);
}

void mostrarContacto(Contacto contacto) {
    printf("NOMBRE: %s\n",contacto.nombre);
    printf("DIRECCION: %s\n",contacto.direccion);
    printf("TELEFONO: %s\n",contacto.telefono);
    printf("------------------------\n");
}

void borrarContacto() {
    int posicion=0;
    char conformacion;
    printf("\n\n\n\t\t\tPara borrar...");
    posicion=buscarContacto();
    if (posicion!=ERROR) {
        printf("\nEsta seguro que quiere borrar este contacto? [s/n]");
        if ((conformacion=getchar())=='s'||conformacion=='S') {
            borrarContactoEnAgenda(posicion);
            printf ("El contacto ha sido eliminado\n");
        } else {
            printf ("El contacto NO ha sido borrado\n");
        }
        esperarPorTecla();
    }
}

void imprimirAgenda() {
    register int mostrados=0, siguiente;
    siguiente=recorrerAgenda(0);
    printf("------------------------ NOMBRE DEL LISTIN: %s ------------------------\n", nombreArchivo);
    while(siguiente!= ERROR) {
        if (mostrados==PANTALLA) {
            mostrados=1;
            esperarPorTecla();
            printf("------------------------ NOMBREDEL LISTIN:%s ------------------------\n", nombreArchivo);
        } else {
            mostrados++;
        }
        mostrarContacto(recuperarContactoDeAgenda(siguiente));
        printf("------------------------\n");
        siguiente=recorrerAgenda(siguiente+1) ;
    }
}

void guardarArchivo() {
    if (salvarAgenda(nombreArchivo) == ERROR) {
        printf ("No se pueden guardar datos en el fichero de datos\n");
    } else {
        printf("Datos guardados con exito\n");
    }
}

void modificarContacto() {
    int posicion=0;
    char temporal [100];
    Contacto antiguo, nuevo;
    printf("\n\n\n\t\t\tPara modificar...");
    posicion=buscarContacto();
    if (posicion!=ERROR) {
        antiguo = recuperarContactoDeAgenda(posicion);
        printf("Introduce el nuevo nombre [INTRO para conservar el antiguo]: ");
        gets(temporal);
        if (strlen(temporal)!=0)
            strcpy(nuevo.nombre,temporal);
        else
            strcpy(nuevo.nombre, antiguo.nombre);
        printf("Introduce la nueva direccin [INTROpara conservar la antigua]: ");
        gets(temporal);
        if (strlen(temporal)!=0)
            strcpy(nuevo.direccion,temporal);
        else
            strcpy(nuevo.direccion, antiguo.direccion);
        printf("Introduce el nuevo telefono [INTRO para conservar el anterior]: ");
        gets(temporal);
        if (strlen(temporal))
            strcpy(nuevo.telefono,temporal);
        else
            strcpy(nuevo.telefono,antiguo.telefono);
        modificarContactoEnAgenda(posicion,nuevo);
        printf("El contacto ha sido modificado con xito\n");
    }
}

void esperarPorTecla() {
    printf ("\nPulse una tecla para continuar...");
    getchar() ;
    system("cls");
}
